Overview

This software is used for automating frequent operations and boring routine tasks. It will enable you to solve a wide range of tasks starting from ensuring the safety of your information and ending with reminding you about various events.

There is a lot of software used for various purposes and having a built-in scheduler. xStarter is a task scheduler that can serve a lot of purposes. Moreover, tasks can be triggered not only by time, but also by some system events.

All xStarter tasks are a succession of simple operations. Each operation performs a certain function. All functions can be divided into several groups:
  • Working with software and system services

  • Working with files and folders (copying and moving files and folders, etc)

  • Synchronizing folders

  • Creating ZIP archive;

  • Creating of Windows macros (succession of keyboard strokes and mouse operations)

  • Turning off, restarting or switching the computer to the standby mode

  • Optimizing the computer memory

  • Establishing a RAS connection

  • Downloading and uploading files via the FTP or HTTP protocol

  • Displaying messages on the screen

  • Et cetera, et cetera

            •

    All you have to do is specify a succession of operations with necessary parameters. After that you should set the time when they are to be performed. Afterwards the program will perform all the tasks without any additional activity from you.
    In case of complicated sets of operations, it is possible to record macros. Macros can contain several sets of mouse movements and keystrokes. More information about Windows Macros.


Working with the program

When the program is running, you can see an icon with a small paper plane on it in the system tray area. Left-clicks and right-clicks on the icon of the program open its context menus.

A left-click opens the quick action execution menu. In this menu you can find available actions, the list of actions executed before from action menu along with their parameters. The item at the top of the menu is used for opening the task configuration window. More details about executing actions quickly .

A right-click opens the quick task status modification menu. When the program is launched for the first time, there is only the Examples section in this menu with a small set of sample xStarter tasks. The item at the top of the menu is used for opening the task configuration window. More details about changing the statuses of existing tasks from the context menu .

You can also open the task configuration window with a double-click on the xStarter icon.

The xStarter configuration window is used for creating tasks, choosing a method for running them, as well as for specifying action lists for tasks.

The main configuration window contains the list of sections/tasks in its left pane and a set of options for specifying the parameters of sections/tasks in its right pane.

Task sections are folders used for arranging tasks in a convenient tree-like structure. All tasks of one section are stored in one file in the program folder xStarter/Sections. Thus, they can be easily copied and transferred from one computer to another (for example, from home to work and otherwise).

Each xStarter task has its running parameters and a list of actions that are executed when the task is run. Besides, each task has a name that must be unique and the option defining whether this task is enabled or disabled.

To create a task, you should:
1. Specify a mnemonic name for easier navigation in the task list;
2. Specify parameters for running the task;
3. Specify a list of actions.

A task can be run according to a schedule, on some system event or manually.

The internal scheduler allows you to configure when tasks should be run:
1. Once (at a certain time on a certain date);
2. After a certain period of time;
3. At regular intervals;
4. Using the complex time format (provides for flexible launch configuration by time, weekdays, months, etc.)

You can find the following types among the events that can be used to run tasks:
1. A key combination («hot» keys) has been used;
2. A window has been created / activated / closed in Windows;
3. Files in a certain directory have been modified;
4. No mouse movements or keystrokes have been detected for a certain time;
5. xStarter has been started (you can configure it so that it is started at Windows startup).
6. A record has been added to the NT event log.

More details about configuring task runs according to the schedule and about configuring task runs on certain events .

The list of actions forms an algorithm for carrying out the main purpose of the task. When the tab with the list of actions is activated, there appears a toolbar with buttons that are used to manage actions.

Actions are executed one after another and can be presented either as a list or as a branched structure. A branched structure is introduced with the help of If statements and is used to described task actions depending on varying conditions. More detail about action list .

When you add or edit an action, the window for specifying action parameters appears. The window contains the list of available actions and the area for specifying their parameters. Each action has its set of parameters. For example, the action for starting a program has such a parameter as the file name of the program to be started and the action for stopping a service has the name of the service. Description of action parameters.

Action parameters can contain some functions, task parameters or the results of executing previous actions in the action list. More details about additional parameters .

After you create or modify a task, you should save the changes. You can use the OK or Apply buttons to do that. If you press OK, the task configuration window will be closed.


Quick task creation
1. Activate the task configuration window with a double-click on the program icon. You can also open the configuration window by using the item at the top of both context menus in the program.
2. Create a new task using the toolbar, the main program menu or the context menu in the list of sections/tasks in the left part of the configuration window.
3. Specify parameters for running the task. More details about task running parameters.
4. Create the list of action for the task on the Actions tab. More details about the list of actions . Each action has its own parameters. More details about action parameters .
5. Use the OK or Apply buttons to save the changes.


Quick action execution from the context menu

When you left-click the program icon in the system tray, you will see a menu with the list of action groups and available actions themselves.

When you select the necessary action, the window with its parameters appears. Use this window to configure action parameters, as well as quick action execution parameters. Description of action parameters .

You can configure the action to be executed Now, Once or After a certain period of time.

The action configured to be executed Now will be executed right after you click OK.

When you configure the action to be executed Once, you should specify the exact date and time of the action execution. The action will be executed exactly at the time specified. The action cannot be executed unless the computer and xStarter are running at the specified time.

When you configure the action to be executed After a certain period of time, the action will be executed after the time period specified.

When you click OK, the action either is executed or becomes scheduled to be executed later.

The actions ready to be executed are displayed in the lower item of the quick execution menu. If it is no longer necessary to execute an action, it can be deleted using the Clear item. This operation deletes all actions ready to be executed.

Besides, once you click OK, the new action and its parameters are saved to the quick execution history of the selected action. If the action has at least once been launched before through the quick execution menu, the corresponding submenu with the history of launching the action appears in the quick execution menu. At any moment you can execute the action again with the specified parameters by just selecting the corresponding menu item.

If an action has its execution history, you can execute the action with new parameters using the New action… menu item. If you do not need the execution history any more, you can use the Clear menu item to delete it.


Examples of using the quick execution menu

After you create a set of the most frequently used actions with their parameters, you can use the execution history of these actions day by day.

For example, you can:
Configure the computer to be turned off after an hour or another time period. Each time before going to sleep, you can leave the computer with music or with the TV tuner turned on and select the necessary item for turning off the computer from the quick execution history.
Configure a message about some event to be displayed at the specified time. If you are constantly working with the computer, why should you need notes on your desktop?
Exit a program. It can be useful if some program you need finishes its work with an error. You do not have to open the Task Manager if you can create an action for closing the program and execute it every time you need it from the quick execution history.
When you open a web page, usually you open your web browser first and only then you type in or select from your bookmarks the URL of the page. After you create an action for opening a certain web page, next time you need it, you will be able to select it from the quick execution history of the action. The web browser will automatically open the necessary web page.
Et cetera, et cetera.


Managing existing tasks via the context menu

When you right-click the program icon in the system tray, a menu with the list of task sections and tasks in those sections is displayed. When you only start working with the program, you can find only the Examples section and a set of tasks in that section in this menu.

Each task has a running method specified for it (at a certain time, on a certain event, etc.). But sometimes it is necessary to run some task manually. That is what this menu is used for. Using it, you can quickly find the necessary task, select it and Run.

All tasks have the Enable option. This property defines whether this task will be automatically run according to its running method or not. From the beginning all the tasks in the Examples section are disabled. To be able to run the necessary task, you should Enable it.

Using this menu, you can also Disable a task and it will not be run according to the method specified for it, when it is due.


Prefences

Language
Select language from list of available languages.
If your language does not available in xStarter, you can:
a. translate files xStarter/Languages/english.lng and xStarter/Languages/english_plugins.plg to your language;
b. send them to support@xstarter.com;
c. receive FREE license for xStarter.

Options

Run only manual
xStarter will not be launched on Windows startup if this option is checked.

Run at Windows startup / logon
xStarter will be launched as simple Windows program after logon to computer and full desktop loading.

For all users
This option available only with checked option Run at Windows startup / logon. If this option checked then xStarter will be launched on every Windows user logon. Else only on logon of user who install the program.

Run as service at Windows startup
Program will be launched as Windows NT service on every computer startup. In this mode xStarter tasks can be launched even without/before user logon.

Write all file system events in the program log file
With this option all filesystem changes will be saved in xStarter log file. But only filesystem changes in monitored by xStarter tasks folders.

Do not show xStarter icon in taskbar
In this mode xStarter will be launched by specified mode (see above) but program icon will not appears in Windows taskbar.
This option useful for blocking access to xStarter tasks configuration by children or another users.
In any case xStarter configuration program available from Start/Programs/xStarter menu.


xStartHooks package

Some xStarter events require keystrokes, creating/closing window and other operations with windows to be intercepted. Unfortunately, such malware as viruses, key loggers, adware, etc. use the same functions. A lot of antivirus software (NOD32, Panda, AVG.Anti-Virus used to do it before) and firewalls (ZoneAlarm) display messages about viruses and suspicious activity when the program is running and the xStartHooks module is active.

If you trust us that the xStartHooks module contains neither malicious code nor viruses, you can download this module from here:
http://www.xstarter.com/download/xstarthooks.zip

After you install it, you will be able to remove it in case of annoying messages from antivirus software and firewalls about the danger. You can use the Uninstall menu item to remove it. In some cases, you may need to restart the computer after you select this menu item.


Scheduler

The scheduler implemented in xStarter can run tasks:

At a certain time on a certain date
You should specify the exact time and date when the task should be run.

After a certain period of time
You should specify the time period after which the task will be run. The exact time for running the task is estimated at the moment when the task is saved.
Thus, even if you exit xStarter and then start it again, the task will still be run after the specified period of time since when the task was saved. It will not be run only if the estimated time has been missed.

At regular intervals
You should specify a time interval at which the task will be run again and again. The countdown starts either since xStarter is started or since when the task was saved.

Using the complex time format
You should specify a list of «time masks» for running the task. Each «time mask» is a set of time units. For example, using this mode, you can run the task:
always at 15:30:00;
always at15:30:00 on Tuesdays and Thursdays;
always at 15:30:00 on Tuesdays and Thursdays in February and July;

Or you can specify various combinations of such time units as hours, minutes, seconds. For example, you can run the task:
always at seconds 1,10;
always at minutes 1,10 and at hours 11,19;
always at minutes 1,10 and at hours 11,19 on Tuesdays and Thursdays in February and July;

You can specify units when to run the task either as a simple enumeration (selecting from the list of possible values) or as intervals during which the task will be run at the specified steps. For example, if a task is set to be run at 14:00:00 on days from 1 to 10 at steps 2 and on days from 15 to 30 at step 3, the task will be run at 14:00:00 on days 1,3,5,7,9, 15,18,21,24,27,30 of any month.

When this mode is selected, the list with «time masks» and buttons for editing the list are displayed.

Add simple
Adds a simple mask where it is possible to specify the time for running the task, enumerations and intervals for days, as well as weekdays and months in the list of «time masks». When you click the button, an additional window is displayed, where you can enter the necessary parameters. For each time unit there is a different tab with the corresponding options. The tab for days consists of two separate parts for specifying enumerations and intervals.

Add complex
Adds a compound mask where it is possible to specify enumerations and intervals for seconds, minutes, hours and days, as well as weekdays and months in the list of «time masks». When you click the button, an additional window is displayed, where you can enter the necessary parameters. For each time unit there is a different tab with the corresponding options. The tabs for seconds, minutes, hours and days consist of two separate parts for specifying enumerations and intervals.

After you make an addition to the list of «time masks», fields for a new mask appear.

Edit
Opens the window for editing parameters. There should be a «time mask» selected in the list.

Delete
Deletes a «time mask» from the list. There should be a «time mask» selected in the list.


Configuring tasks to be run on certain events

Tasks can be run on the following events:

  • A key combination («hot» keys) has been used

  • A window has been created, or activated, or closed in Windows

  • Files in a certain directory have been modified

  • After some idle time

  • xStarter has been launched

  • A record has been added to the NT event log.


Hot keys

You should specify a combination of character and service keys with Ctrl, Alt, Shift that will run the task.


On an Window command

You should specify the title of the window that will run the task. You can select the title of the window from the list of currently opened windows or enter it manually. You can use the wildcards characters «*» and «?» while entering the window title.

The program will respond to the windows that correspond to the specified window title. Besides, all the «*» characters in the specified title can be replaced with any number of characters, while the «?» characters can be replaced with only one character.

For example, if you create a task that should be run when a window titled «*Microsoft Word» is activated, the task will be run when any window the title of which ends with the text «Microsoft Word» is activated. It can be «Untitled1 - Microsoft Word» or «Resume - Microsoft Word».


On an File or Folder changing

The task will be run when any changes take place in the specified folder. If the Subfolders mode is on, changes in the subfolders of the specified folder will be also monitored.

The Folder create/change/delete option defines whether changes of the folder itself should be monitored.
If the All file operations mode is on (or partially on), changes to the files in the specified folder (but not in its subfolders are monitored).
The File create, File change, File delete options define exactly what changes to files to monitor.
If in monitored folder will be copied file then first will take place event File create and after if File change. In case of used program for coping second event can do not take place (e.g. if copy with Explorer).
If option File create is active then available option Wait creating (coping) finishing. If this option checked then event will take place only after finishing file creating/coping.
It is possible to specify masks for file names that will run the task once they are modified. You can enter masks for file names in the File names field and use the «;» character as a separator.

For example, if you enter «*.txt;*.doc» into the File names field, the task will be run only when the specified changes will be made to files with the specified extensions.
You can use a number of parameters for the actions of the task that will be run by an event connected with the changes in the file system. More details about the parameters of file system events.


Idle time

The task will be run if no mouse movements or keystrokes have been detected for the time specified in the Idle time field.


On xStarter launching

The task configured to be run on this event will be run when xStarter is started. If the program is started at Windows startup, the task will be launched exactly at that moment.

Note: xStarter can be running as an NT service. All tasks configured to be run when xStarter is started will be run even before the user logs into the system.


NT event log

This event take place then a record has been added to the NT event log.

You should select a Source for the task to be run when a record is added to it. You have the following choice of sources: Application, Security, System.

You should also select the Event type that will run the task. This parameter can take the following values: Error, Warning, Information, Success, Audit, Failure Audit.

If the task must be run irrespective of the Event type, you should select the All event types option.

You can filter messages by their text. To do that, you should specify the Message contain field. The task will be run only if a message added to the NT event log contains the text specified in this field.

If you do not need to filter messages by their text, you should select the All messages option.
You can use a number of parameters for the actions in the task that will be run on an event connected with records added to the NT event log. More details about the parameters of events connected with adding records to the NT event log.


The list of task actions

Each task has a list of actions. You can find this list on the Actions tab. Along with actions you can find the If and TextLoop statements in this list. Statements have a blue background.

The list has a tree-like structure, thus, all actions related to a certain statement are within this statement. If an action is not related to any statement, it is at the top level of the tree.

To manage actions and statements, you should use buttons on the toolbar above the action list, or the context menu, or the main menu of the program.

New action…
When you use this command, the window where you can select the necessary action or expression appears. In this window you specify parameters for the action or the statement.

Edit action…
When you use this command, the window where you can change the action type or edit its parameters appears.

Note: You cannot turn a statement into an action or vice versa, as it would change the hierarchic structure of the action list.

Drop action
This command allows you to remove an action or a statement from the list. When you remove a statement, all actions related to it are also removed.

Note: The program will not let you drop an action the parameters of which affect an If statement.

Up action
Down action
Use these items to move actions and statements up or down the list. When you move a statement, all the actions related to it are also moved.

Note: The program will not let you move an action the parameters of which affect an If statement to a position lower that that of this statement.


Description of Actions' Parameters

Each Action is designed for providing particular functionality. An Action has an own set of Input Parameters, as well as a proper set of Output Parameters that represent results of the operation performed. Input Parameters can be defined as simple values as well as compound values. Output Parameters of previous Actions or Expressions from the current Task's list of Actions can serve as compound values for Input Parameters of a particular Action. Parameters of an Event that caused the Task's execution and Internal Functions can be used as Input Parameters too. See more about Event parameters and Internal Functions .

Each Action has "Success" Output Parameter, which shows whether the Action was successfully executed. "Success" can be negative in cases of missing files or folders, or inability to perform the desired operation, or server connection failure etc. No failure alerts are shown at the desktop. All error messages are saved into the application's log file (xstarter.xlg).


Additional parameters

Each text parameter of an Action can accept both simple values and compound values such as:
q Output Parameters of Actions executed before the current Action;
q Parameters of Events that caused the Task's execution;
q Internal Functions.

All these compound parameters are calculated and substituted with real values on the Action's startup.

For example, if you set Message parameter of ShowMessage Action to "Hello {COMPUTERNAME}", the message will appear as "Hello MYHOMECOMP" (where MYHOMECOMP will be the real name of your computer).

To insert an Output Parameter or an Internal Function into the Input Parameter of an Action, the steps below should be followed:
1. Place the mouse cursor in the exact place of the text field where you would like to insert the Output Parameter or an Internal Function.
2. If parameter/function insertion is available, Paste Function button will be enabled in the lower part of the form. You would need to click it.
3. A new window will pop up where you would need to select the particular item from a list of available parameters and functions (the item will be pasted into the text field).
4. To paste the selected parameter/function, it's needed to press OK button. If the button is disabled, this means that no item is selected in the list.

To make the selection process more convenient, all parameters and function are split into groups. You would need to select the group first (otherwise the required parameter/function might be overlooked) and then choose a particular parameter or Internal Function.

Results
If Results group is selected, then Actions and Expressions are displayed that are placed before the current Action in the list of the Task's Actions. Output Parameters of the Actions and Expressions are displayed as well.

Events results
This group contains parameters of Event that caused the Task's execution. If the Task was started not because of the Event, then the chosen parameter will be substituted by an empty value.
For example, if the Task was started according to a schedule, and one of its Input Parameters contains [FileEvent.NewFile], then this parameter will be substituted by an empty value on the Action's startup.

List of Triggers' parameters.

FileEvent.NewFile - New file name
FileEvent.UpdFile - Changed file name
FileEvent.DelFile - Deleted file name
FileEvent.NewFileShort - New file short name
FileEvent.UpdFileShort - Changed file short name
FileEvent.DelFileShort - Deleted file short name
FileEvent.SubFolder - File event's sub folder name
FileEvent.Folder - File event's folder name

NTEVENT.TYPE - Event type
NTEVENT.Category - Event category
NTEVENT.Computer - Event computer
NTEVENT.UserName - Event username
NTEVENT.RecordNumber - Event record number
NTEVENT.Message - Event message
NTEvent.Source - Event source
NTEvent.ID - Event ID
NTEvent.Date - Event date
NTEvent.Time - Event time
WinEvent.WinTitle - Window title
WinEvent.WinClassName - Window class name
WinEvent.WinTop - Window top coordinate
WinEvent.WinLeft - Window left coordinate

ComEvent.String
Received from serial port string

All Functions
Internal Functions used in Actions' Input Parameters are substituted by calculated values on Actions' startup.

Date & Time

DATE
Current date
TIME
Current time
LONGTIME
Current time in long format
TIMEWOCOLON
Current time with "_" insted ":"
YEAR
Current year
MONTH
Current month
DAY
Current day of month
HOUR
Current hour
MINUTE
Current minute
SECOND
Current second
MILLISECOND
Current millisecond

Text

ENTER
Enter

System Info

COMPUTERNAME
Computer name
USERNAME
User name
DOMAINNAME
Domain name
WINDOWSVERSION
Windows version
NTPRODUCTTYPE
NT product type
WINDOWSSERVICEPACKVERSION
Windows service pack version
PROGRAMFILESFOLDER
Program Files directory
WINDOWSFOLDER
Windows directory
WINDOWSSYSTEMFOLDER
Windows system directory
WINDOWSTEMPFOLDER
Windows temp directory
DESKTOPFOLDER
Desktop directory
PERSONALFOLDER
Personal directory
INTERNETCACHEFOLDER
Internet cache directory
COOKIESFOLDER
Cookies directory
HISTORYFOLDER
History directory


RunProcess

This Action is designed for starting an application or opening a document. Documents are opened by applications that are registered as default openers for particular types of documents in the operating system.

File Name
This is a name of the application to be run or the document to be opened. This can be either a full path to the file or just a short path. If short path is used, the application/document should be located either in Default Folder or in the path registered in Windows' environment variables.

Windows standard applications, such as Notepad.exe or Defrag.exe are usually located in folders that are registered in Windows' environment variables by default. Full path is not required for such programs.

The program's name can be selected from the list of running applications.

Parameters
Some programs have command line switches that are used to specify the program's behavior. To find out, which command line switches are suitable for your situation, please refer to the program's documentation or try locating appropriate information through search engines on the Internet. (Use the program's name and "command line" or "command line switches" as keywords for the search.)

Default Folder
This is a default folder where programs and documents will be looked for in. If you are going to use full paths in File Name parameter, this setting can be left blank.

Window
This setting defines the window's state for the program to be run. It can be selected from the list of values: Normal, Minimized, Maximized, and Hidden.

Wait until the Application Exits
This setting defines whether xStarter should wait for the program's exit or immediately proceed to and run the following item from the list of Actions.

Examples:
Defrag c:
cleanmgr /d c: /sageset:11
cleanmgr /d c: /sagerun:11

Note: All switches (going after the first space character) mentioned in the samples above should be placed into Parameters.


TerminateProcess

This Action is designed for shutting down a program.

Program Name
You can either manually enter the program's name or choose it from the list of currently running applications.

Wait time (s.)
This is a time period to wait for the program's shutdown. If not equal to 0 then after the time span expires, and the program is still running, the program is forcedly closed.


SendKey

This Action is designed for sending a combination of keys (or a text fragment) to the selected application.

Program Name
This is the name of the program where the keys pressings (or the text) should be sent to. You can either manually enter the program's name or choose it from the list of currently running applications.

Sendkeys String
This is a string to be sent. It's possible to use regular characters, SHIFT, CTRL and ALT modifiers and special characters.
For example, if you need to send CTRL+P to the application, you would need to input the CTRL modifier and the "p" character: ^(p).

Note: Regular characters should be entered in lower case and using regular Latin keyboard layout.

Add Keyname
This setting adds a name for a Functional key (F1…F12, DOWN, UP etc.). You will need to select the required key from the field to the left of the button. Also can be added DELAY parameter what specify pause in milliseconds.

Add Modifier
This setting adds a modifier chosen in the field near the button.
The modifiers currently are:
+() for SHIFT,
^() for CTRL, and
%() for ALT.

Wait
This setting defines whether xStarter should wait until all characters are sent to the application.


LaunchedProcessCount

This Action returns a number of running instances for a particular program. It can also be used for obtaining information on whether a particular program is currently started at all.

Program Name
This is a name of the application, for which we need to determine a number of running instances. You can either manually enter the program's name or choose it from the list of currently running applications.

Results:
Count
This is a number of currently running instances of the particular program.


Shutdown

This Action is designed for powering off the computer.

Force Applications to Close
During computer shutdown, some running applications can possibly ask a user something on their closure. For example, Microsoft Word having unsaved documents would ask a user to save the changed documents before shutting down.

If the setting is turned off, then if there are running programs that pop up prompts requiring user input, the computer will not be turned off. Therefore, if there are unsaved documents in running applications, the computer will not be turned off.

If the setting is turned on, the operating system will forcedly close all applications even if they require user actions (e.g. save a file). Such applications will be closed anyway after timeout expiration, and all unsaved data will be lost.


Reboot

This Action is designed for rebooting the computer.

Force Applications to Close
During computer shutdown, some running applications can possibly ask a user something on their closure. For example, Microsoft Word having unsaved documents would ask a user to save the changed documents before shutting down.

If the setting is turned off, then if there are running programs that pop up prompts requiring user input, the computer will not be turned off. Therefore, if there are unsaved documents in running applications, the computer will not be turned off.

If the setting is turned on, the operating system will forcedly close all applications even if they require user actions (e.g. save a file). Such applications will be closed anyway after timeout expiration, and all unsaved data will be lost.


Logoff

This Action is designed for logging off the current user from the computer (without shutting down or rebooting the computer).

Force Applications to Close
During computer shutdown, some running applications can possibly ask a user something on their closure. For example, Microsoft Word having unsaved documents would ask a user to save the changed documents before shutting down.

If the setting is turned off, then if there are running programs that pop up prompts requiring user input, the computer will not be turned off. Therefore, if there are unsaved documents in running applications, the computer will not be turned off.

If the setting is turned on, the operating system will forcedly close all applications even if they require user actions (e.g. save a file). Such applications will be closed anyway after timeout expiration, and all unsaved data will be lost.

Lock Workstation
This setting tells xStarter not to logoff the current user, but to lock the computer instead. If the setting is turned on, "Force Applications to Close" setting does not affect xStarter in any way. None of currently running programs will be closed - all of them will remain running, but the workstation will be locked, and a password will be required for unlocking.
The setting can be used, for example, for locking out a workstation when no mouse clicks and no key pressings are detected by the system for a long time in order to avoid an unauthorized access to the computer.

Note: This option is available only for Windows NT family of operating systems.


Sleep

This Action is designed for taking the computer into the sleeping mode.

Suspend Technique
If the setting is turned on, xStarter uses the operating system's sleep mode in order to suspend operations. If not, it suspends operations using hibernating.

Forced Suspension
This setting tells xStarter to forcedly close all running applications. If the setting is turned off, the computer is not taken into the sleeping mode unless there are no running applications that prompt user input on their closure.


ShowMessage

This Action is designed for showing messages as windows popping up on the desktop. This Action can be used for making reminders about upcoming Events or as a messenger on particular operations' completion etc.

Message
This setting contains the text of the message.

Message Icon
This setting designates the type of the icon that appears within the message. The type can be one of the following:

None
Information
Warning
Error
Question


AskMessage

The Action is designed for making prompt messages appear on the desktop. The message window contains buttons "Yes" and "No" along with the text of the message and a question icon. Depending on the user's answer, the Output Parameter of the Action is set to the corresponding value. This Output Parameter can be further used in If Statement. See more on Statements .

Message
This setting contains the text of the message.

Results:
Yes
This parameter is set to TRUE when "Yes" button is clicked.


NetworkMessage

This Action is designed for sending messages over a local network. This Action can be used on Windows NT family operating systems only.

Computer
This is a name of the computer in a local network, where the network message should be sent. This machine should have the messaging service running in order to accept the network message.

Message
This setting contains the text of the message.


Copy

This Action is designed for copying files and folders.

Source File Name(s)
This setting contains files that have to be copied. It is possible to use wildcards in files' names, for example c:\My documents\*.doc. It is also possible to input folders' names.

Destination Path or File Name
This is the path where the file has to be copied to.

Select Folder
When the button is clicked, a list of folders is displayed. When a particular folder is chosen and OK button is clicked, the folder's name is pasted into the corresponding field.

Select File(s)
When the button is clicked, a list of files is displayed. When a particular file is chosen and OK button is clicked, the file's name is pasted into the corresponding field.

Files Only
This setting allows copying files only (if Source File Name(s) contains the *.* wildcard).

Overwrite if Exists
If the setting is turned on, all files in the destination location having same names as the source files are overwritten. If the setting is turned off, the files are be copied to the destination location as Copy of <Filename>.


Delete

This Action is designed for deletion of files and folders.

File or Folder to Delete
This field contains full path to the file or folder that needs to be deleted. It is allowed to use wildcards in the file (folder) names, e.g. c:\My documents\*.doc.

Select Folder
When the button is clicked, a list of folders is displayed. When a particular folder is chosen and OK button is clicked, the folder's name is pasted into the corresponding field.

Select File(s)
When the button is clicked, a list of files is displayed. When a particular file is chosen and OK button is clicked, the file's name is pasted into the corresponding field.


CreateFolder

This Action is designed for created specified folder.

Folder Name
This setting defines an Folder name.


Synchronize Folders

This Action allows you to synchronize files/folders between two PCs on a local computer or across a network.
It can be triggered by the advanced scheduler on a wide range of system events. For example, it can be launched after file or folder creation, modification or deletion.

xStarter can execute a wide range of other xStarter automated tasks before or after synchronization. For example, you may need to archive data, send email notifications, run another process, execute a windows macro, before or after synchronizing.

In the near future we will be adding a function for synchronizing local folders with FTP folders.

Source Dir
This is a full path to the folder that the Target Dir is synchronized with.

Target Dir
This is a full path to the folder which is synchronized with Source Dir.

Exists Only in Source Dir
Copy File or Dir
This setting tells xStarter whether it should copy a file if it exists only in Source Dir (i.e. in location that files are synchronized with).
For example, folders "c:\MyWorkFiles\" and "c:\MyHomeFiles" are being synchronized, and the first folder contains "doc1.txt" file, but the second folder is missing the file. This setting would define whether "doc1.txt" file should be copied to "c:\MyHomeFiles" folder.

Exists Only in Target Dir
Delete File or Dir
This setting defines whether xStarter should delete a file that exists only in folder that is being synchronized with another folder.
For example, folders "c:\MyWorkFiles\" and "c:\MyHomeFiles" are being synchronized, and the second folder contains "doc1.txt" file, but the first folder is missing the file. This setting would define whether "doc1.txt" file should be deleted from "c:\MyHomeFiles" folder.

Exists in Source and Target Dirs
This setting defines whether xStarter should copy a file if it exists in both folders.

Copy if Size Differ
The file will be copied if sizes of source and target files differ.

Copy if Attributes Differ
The file will be copied if attributes of source and target files differ.

Copy if Times Differ
The file will be copied if "last modification time" records of source and target files differ.

Copy only recent files
It allows to not copying files in the target folder if files are newer on the source folder. For example It can be used, for synchronizing desktop and laptop computers and not overwriting newer files on another side.

Copy new and changed files in differences dir
There are possibility to copy only new or changed files in third folder called as Differences dir. It can be useful for sending to your customers only changed or new files from last sending.


SearchFiles

This Action is designed for seaqrching files with specified filenames. It can be useful for receiving list of files in folder to copy them, send by email, etc.

Search in dir
This parameter contain folder name in which will be runned search.

File masks
SearchFiles action will find all filenames what match to specified file masks. In this value can be used symbol '*' and '?', each file mask mast be separated from another mask by delimiter symbol ';'. For example, this field can contain such values:
*.* - will be searched all files in the folder
*.zip - will be searched only zip files
*.zip;*.exe;*word.zi?

Exclude files masks
SearchFiles action will not return filenames what match to Exclude file masks, even if this filenames match to File masks.

Delimiter text
The result of action execution is a string. A delimiter must exist for dividing one file from another.

Results
Files
This result parameter contain founded filenames separated by Delimiter text. For example, it can be 'winword.exe;excel.exe'

FilesIndexes
This result parameter contain indexes of founded filenames separated by Delimiter text. For example, it can be '1;2'


FileProperties

This action designed for extracting file properties, such as FileSize, CreationTime, etc. Can be useful for executing some actions (statements) only if file have Size more then specified, etc.

Filename
Name of the file that properties will be extracted.

Results

IsDirectory

FileSize

CreationTime

LastAccessTime

LastWriteTime

IsReadOnly

IsSysFile

IsArchive

IsHidden


FirstLastFile

Main gole of this action - return filename of first of last file in specified folder by some file attributes. It can be used, for example, for searching file with maximum size in the folder or last modified file.

Folder name
Name of the folder in that will be processed search.

Search
Here is can be selected what file will be searched: First file (with minimum values) or Last file (with maximum values).

By attribute
Search can be launched by such attributes as Size, Name, Creation date/time, Last modification date/time, Last access date/time.

Results
Filename

Path
Full path to founded file


FileNames

This action designed for extracting some parts of specified filename, e.g. extension, drive, path, etc.

FileName
Full name of the processed file.

Results

Filename
This parameter is equal to input FileName

Shortname

Path

Ext

Drive


SearchFolders

This action can be useful for searching folders in the the specified folder for processing them in other actions.

Search in dir
Folder name in that search folders.

Delimiter text
The result of action execution is a string. A delimiter must exist for dividing one folder name from another.

Results

Dirs
Founded folders with full paths.

DirsIndexes
Indexes of founded folders.

DirNames
Shortnames of founded folders.


Windows Macros

A lot of software has a mode for recording some macros - sequences of frequently used actions. But they are local solutions that can be used only with that specific software.

With xStarter, you can record macros working in all programs and objects within the Microsoft Windows environment.

Each macro is a recorded sequence of keystrokes and mouse movements / clicks. For example, you can record how you double-click the icon of a program, enter your password while accessing the program program, move the mouse to the main menu, select the mode you use most frequently, etc.

The entire set of all those actions is saved to a file using the Macros / Record mode making it possible for you to carry out those operations again using this mode.

Use the Filename field to specify the full path to the file where the set of your mouse movements / clicks and/or keystrokes will be saved. After you click the Start record button, the window of xStarter will be hidden, the operations will start being recorded, in the lower-right corner of the desktop there will appear a window informing you that the recording process is in progress and that it can be stopped with the Ctrl+Alt+F12 key combination.

You can also Stop recording with the Ctrl+Alt+Del key combination (you will not restart the computer if you use this combination only once).

To execute the recorded macro, you should leave the name of the file with the recorded actions in the Filename field and save it as an action. When the task with this action is launched and it comes to executing the action with the recorded macro, all the operations saved in this file will be carried out.

Note: It is not recommended to record how you enter any of your passwords, as it can result in an unauthorized access to the data / software that you keep protected.


How To Register

Registration benefits:
  • No nags during program work!

  • FREE upgrade to new versions!

  • FULL technical support including support via e-mail!

  • Product notification by e-mail!

    • We use RegNow, RegSoft and ShareIt - well known payment service providers that allow to order xStarter securely online with a credit card, or by phone, by fax or whatever you desire, even old post mail orders with bank check.

    Secure Online Order:
    This is the fastest and easiest way to register xStarter. Just follow the link below and place an order:

    www.xstarter.com/order.html


StartService

This Action is designed for starting an NT service.

ServiceName
This field is used for choosing a service from a list of existing services on the computer.

Wait Until Started
This setting defines whether xStarter should wait until the service is started, before proceeding to the next Action (some services take a long time to start up).


StopService

This Action is designed for stopping an NT service.

ServiceName
This field is used for choosing a service from a list of existing services on the computer.

Wait Until Stopped
This setting defines whether xStarter should wait until the service is stopped, before proceeding to the next Action (some services take a long time to stop).


Zip

This Action is designed for archiving files and/or folders in ZIP format.

Files and Folders List
This is a list of files and folders to be archived.

Add Folder
When the button is clicked, a list of folders is displayed. When a particular folder is chosen and "OK" button is clicked, the folder's name is added to the list of files/folders to be archived.

Add File(s)
When the button is clicked, a list of files is displayed. When a particular file is chosen and "OK" button is clicked, the file's name is added to the list of files/folders to be archived.

Delete
When the button is clicked, the highlighted item is removed from the list of files/folders to be archived.

Name of Archive
This is a name of the archive (e.g. "c:\Arc\mydocs.zip").

Add Subfolders
This setting defines whether it's required to archive subfolders as well.

With Full Folders Structure
If the setting is turned on, files will be saved with the full current folders' structure in the archive. If the setting is turned off, information about the current folder and its subfolders only will be saved into the archive.

Password
This is a password for archive. Archive will created without password if this field is empty.


Backup

This Action is designed for creating a backup for a list of selected files and/or folders. The backup file is represented by a ZIP archive, but its name contains date of archiving. Therefore, if a daily backup is set up, the archives will not overwrite each other, but new archives will have new unique names.
This Action can be used, for example, for making daily backups of "c:\My documents" folder or database files in order to have a chance, in the future, to view the files' state for a certain date.

Files and Folders List
This is a list of files and folders to be archived.

Add Folder
When the button is clicked, a list of folders is displayed. When a particular folder is chosen and "OK" button is clicked, the folder's name is added to the list of files/folders to be archived.

Add File(s)
When the button is clicked, a list of files is displayed. When a particular file is chosen and "OK" button is clicked, the file's name is added to the list of files/folders to be archived.

Delete
When the button is clicked, the highlighted item is removed from the list of files/folders to be archived.

Backup's Folder
This is a folder where backup files will be stored in. For example, this can be "c:\Archives".

Base name of Backup
This setting contains a base name for backup files. For example, if the base name is "mydocs", then names of backup files would be: mydocs01_06_2004.zip, mydocs02_06_2004.zip etc.

Password
This is a password for archive. Archive will created without password if this field is empty.


DeleteOldBackups

This Action is designed for deletion of backup files. The deletion is done according to predefined format. If backup files are created daily, these archives might not be needed if they are older than 1, 2 or 3 months. Therefore, you might wish to remove older files (e.g. created a year ago). It might be enough to keep backup files created on particular days of week/month, and to remove other old backups for clearing disk space.
Note: It is not required to permanently remove currently needless backup files that might become useful in the future. You might consider moving such files to CD-R/RW or DVD-R/RW media with the use of specialized software.

Backup's Folder
This is the folder where backup archives will be deleted from. For example, this can be "c:\Archives".

Base name of Backup
This is a base name that was used for creating backup files (e.g. "mydocs").

Backups to Keep
This set of settings defines which backup files have to be kept.

Created at Weekday
This setting tells xStarter not to remove backups created on days of the week that are selected here.

Created at Day(s) of Month
This setting allows selecting days of the month, for which backups, created on those days, have to be kept. The days can be enumerated as a comma-separated list (e.g. "1,15,30").


Connect

This Action is designed for making connection to a remote network. This can be either a regular modem connection or a GPRS or VPN connection.

Dialup Connection
This field allows choosing a connection from the list.

Number of Attempts
This setting defines a number of retries to be made if the first attempt is not successful.

Connect as User
This setting defines whether xStarter should use connection parameters pre-defined in the connection or additionally prompt for the parameters.

User Name
This is a user login to be used for connecting to the remote network.

User Password
This is a user password to be used for connecting to the remote network.


Disconnect

This Action is designed for closing a connection to a remote network. This can be either a regular modem connection or a GPRS or VPN connection.

Dialup Connection
This field allows choosing a connection from the list.


Send mail

This Action is designed for sending electronic mail messages. This Action can be useful, for example, for sending emails on exact time, which would contain reports on some fulfilled operations.
Most of cellular operators offer an ability to send SMS messages to a cell phone through an email address. Therefore this Action can be used for sending SMS messages as well.

From Address
This setting defines an email address to be used as "From" address.

Mail Host
This setting defines a mail server that will be used for sending email messages. The mail server should support SMTP protocol and be accessible from the computer where xStarter is run at. For example, this setting can be either a domain name of type "smtp.mymail.com" or an IP address of your ISP's mail server of type "XXX.XXX.XXX.XXX".

Port
This is the mail server's port, which is used for accepting SMTP connections. Most common value for the port is 25.

User Name
This is a login name of the user's mail account, which is used for sending mail through the server. For example, this can be "john_smith" or "john_smith@mymail.com".

Password
This is a password of the user's mail account, which is used for sending mail through the server.

To Address
This setting defines, which email address should be used as "To" address.

Subject
This setting contains a subject of the email.

Message
This setting contains a message to be sent in the email.

File
This is a file to be attached to the email.


CheckMail

This Action is designed for checking mail on a mail server. The check is performed via POP3 protocol. This Action can be used for getting information on new emails' arrival. Therefore, for example, the computer can be remotely managed by sending emails with particular subjects and bodies to a particular email address.

Mail Host
This is a domain name / IP address of the mail server, which supports POP3 protocol.

Port
This is the mail server's port, which is used for accepting POP3 connections. Most common value for the port is 110.

User Name
This is a login name of the user's POP3-account on the mail server.

Password
This is a password of the user's POP3-account on the mail server.

Text Delimiter between Mails
After checking mail, the Action returns the received emails as its Output Parameters. The Output Parameters contain subjects, bodies of the emails etc.
This setting defines which string should serve as a delimiter for separating different emails' bodies. If the setting is left blank, then the Carriage Return character (ENTER) will be used by default.

For example, if the delimiter is set to |||, and there are two messages on the mail server having subjects Hello and Invoice and bodies Hello, John, … and Invoice from Laboratory …, then the Output Parameters will have the following text blocks returned: MessSubjects will be Hello|||Invoice and MessTexts will be Hello, John, …|||Invoice from Laboratory ….

Results:
MessCount
This is the total number of email messages.

MessTexts
This parameter contains bodies of all messages delimited by the predefined delimiter.

MessSubjects
This parameter contains subjects of all messages delimited by the predefined delimiter.

MessUidls
This parameter contains unique identifiers of all messages delimited by the predefined delimiter.


DeleteMail

This Action is designed for removing messages from a mail server.

Mail Host
This is a domain name / IP address of the mail server, which supports POP3 protocol.

Port
This is the mail server's port, which is used for accepting POP3 connections. Most common value for the port is 110.

User Name
This is a login name of the user's POP3-account on the mail server.

Password
This is a password of the user's POP3-account on the mail server.

Message UIDL for Deleting
This setting contains a unique identifier of the email message that has to be deleted. This ID can be obtained from Output Parameters of CheckMail Action.
For example, after performing CheckMail Action a TextLoop is created that looks into emails' subjects. Depending on the subject, particular emails are deleted from the mail server, and a corresponding part of CheckMail's MessUidls text block is used as the UIDL parameter. GetTextBlockN Action can be used in order to pick the corresponding UIDL parameter.

Delete all messages
All messages in mailbox will be deleted with this option checked.


Pause

This field is used for setting a pause between executions of Actions from the list of the Task's Actions. It can be used, for example, for making a pause between connecting to a remote network and downloading files from the Internet or for a pause between opening a document and sending a combination of keys to the document opener.

Pause Time
Min(s)
Sec(s)
This setting defines a time span for the pause in minutes and seconds.


EnableTask

This Action is designed for enabling a particular xStarter Task. It can be used, for example, for enabling a Task of periodical checking mail.

Task Name
This setting defines an xStarter Task. The Task can be selected from the list of existing Tasks.


DisableTask

This Action is designed for disabling a particular xStarter Task. It can be used, for example, for disabling a Task of periodical checking mail upon pressing special combination of keys (e.g. before leaving the office).

Task Name
This setting defines an xStarter Task. The Task can be selected from the list of existing Tasks.


RunTask

This Action is designed for launching a particular xStarter Task. It can be used, for example, for launching a Task from another Task.

Note: This action just launch task and don't wait while it's finish work.

Task Name
This setting defines an xStarter Task. The Task can be selected from the list of existing Tasks.


Ping

This Action is designed for checking TCP/IP connectivity to a particular Internet server or a computer in the local network.

Note: It can work not correctly in networks with Firewalls.

Host
This is an address of the Internet server or a computer in the local network.

Results:
ReplyTime
This is response time (in milliseconds) of the machine being Pinged.


OpenWebPage

This command is used for opening a specified web page in the default browser.

Webpage to Open
This is a URL (web address) of the web page that has to be opened in the default browser.


Download

This Action is designed for downloading files from the Internet via HTTP protocol. This can be used, for example, for downloading files on schedule or by triggering a particular Event.

URL
This is the Internet address (URL) of the file that needs to be downloaded (e.g. "http://www.xStarter.com/download/xstarter.zip ").

Local Filename
This is the local file name where the downloaded file should be stored to (e.g. "c:\downloads\xStarter.zip").

Use Proxy
This setting enables HTTP connection via a proxy-server.

Proxy Host
This setting defines a name of the proxy.

Proxy Port
This setting defines a port for the HTTP-proxy.

Username
This setting defines a login name for the user on the proxy server.

Password
This setting defines a password for the user on the proxy server.


FtpSyncDownload

This Action is designed for FTP folder and local folder synchronization. This can be useful for scheduled downloads or getting files from an FTP server (e.g. website logs) upon triggering a particular Event. Also it can be useful for home and work computers files synchronization via FTP server.

Ftp folder
FTP server folder. For root FTP folder it's possible to use "/".

Local folder
Local computer folder.

Include files
Synchronize files only by specified mask, for example "*.zip;docs?.xls". If this field is empty then using mask "*.*".

Exclude files
Do not inlcude in synchronization files by specified mask, e.g. "*.exe". This field have higer priority then Include files.

FTP Host
This is a name of the FTP server (for example, "ftp.xStarter.com").

Port
FTP server port. Usually must have value 21.

Username
This setting defines a login name for the user on the FTP server.

Password
This setting defines a password for the user on the FTP server.

Binary mode
Binary mode of files transfer.

SSL connection
This option allow connect to FTP server with using encrypted SSL/TLS connection. For establishing such connection you need additional library OpenSSL:
http://www.xstarter.com/download/openssl-0.9.7f-win32.zip

Use firewall (proxy server)
This connection mode needs if computer have not directly Internet access and connect to FTP server through firewall or proxy server.

Connect method
There are several connection modes available. Each FTP proxy server may have each own mode, it's possible to select more appropriate mode for current FTP proxy server or firewall.

Firewall host
Firewall or proxy server address in local network.

[Firewall] Port
Firewall or proxy server port.

Firewall username
Firewall or proxy server username. It can be empty if not specified at firewall or proxy server.

[Firewall] Password
Firewall or proxy server password.


FtpSyncUpload

This Action is designed for FTP folder and local folder synchronization. This can be useful for scheduled downloads or getting files from an FTP server (e.g. website logs) upon triggering a particular Event. Also it can be useful for home and work computers files synchronization via FTP server.

Local folder
Local computer folder.

Ftp folder
FTP server folder. For root FTP folder it's possible to use "/".

Include files
Synchronize files only by specified mask, for example "*.zip;docs?.xls". If this field is empty then using mask "*.*".

Exclude files
Do not inlcude in synchronization files by specified mask, e.g. "*.exe". This field have higer priority then Include files.

FTP Host
This is a name of the FTP server (for example, "ftp.xStarter.com").

Port
FTP server port. Usually must have value 21.

Username
This setting defines a login name for the user on the FTP server.

Password
This setting defines a password for the user on the FTP server.

Binary mode
Binary mode of files transfer.

Passive mode
Passive mode for FTP connection.

SSL connection
This option allow connect to FTP server with using encrypted SSL/TLS connection. For establishing such connection you need additional library OpenSSL:
http://www.xstarter.com/download/openssl-0.9.7f-win32.zip

Use firewall (proxy server)
This connection mode needs if computer have not directly Internet access and connect to FTP server through firewall or proxy server.

Connect method
There are several connection modes available. Each FTP proxy server may have each own mode, it's possible to select more appropriate mode for current FTP proxy server or firewall.

Firewall host
Firewall or proxy server address in local network.

[Firewall] Port
Firewall or proxy server port.

Firewall username
Firewall or proxy server username. It can be empty if not specified at firewall or proxy server.

[Firewall] Password
Firewall or proxy server password.


FtpDownload

This Action is designed for downloading files from the Internet via FTP protocol. This can be useful for scheduled downloads or getting files from an FTP server (e.g. website logs) upon triggering a particular Event. For using this action you must specify exactly filename. If you need to download list of files or files by wild mask, please, try to use action FtpSyncDownload .

FTP Host
This is a name of the FTP server (for example, "ftp.xStarter.com").

FTP Filename
This setting defines a remote file name on the FTP server (for example, "files/log_may.log").

Local Filename
This setting defines a local file name at local computer (for example, "c:\InetLogs\log_may.log").

Username
This setting defines a login name for the user on the FTP server.

Password
This setting defines a password for the user on the FTP server.

Binary mode
Binary mode of files transfer.

SSL connection
This option allow connect to FTP server with using encrypted SSL/TLS connection. For establishing such connection you need additional library OpenSSL:
http://www.xstarter.com/download/openssl-0.9.7f-win32.zip

Use firewall (proxy server)
This connection mode needs if computer have not directly Internet access and connect to FTP server through firewall or proxy server.

Connect method
There are several connection modes available. Each FTP proxy server may have each own mode, it's possible to select more appropriate mode for current FTP proxy server or firewall.

Firewall host
Firewall or proxy server address in local network.

[Firewall] Port
Firewall or proxy server port.

Firewall username
Firewall or proxy server username. It can be empty if not specified at firewall or proxy server.

[Firewall] Password
Firewall or proxy server password.


FtpUpload

This Action is designed for uploading files to a remote FTP server. This Action can be useful, for example, for publishing new version of files on a web site. For using this action you must specify exactly filename. If you need to upload list of files or files by wild mask, please, try to use action FtpSyncUpload .

FTP Host
This is a name of the FTP server (for example, "ftp.xStarter.com").

FTP Filename
This setting defines a remote file name on the FTP server (for example, "files/ my_prog.zip").

Local Filename
This setting defines a local file name at local computer (for example, "c:\Projects\my_prog.zip").

Username
This setting defines a login name for the user on the FTP server.

Password
This setting defines a password for the user on the FTP server.

Binary mode
Binary mode of files transfer.

SSL connection
This option allow connect to FTP server with using encrypted SSL/TLS connection. For establishing such connection you need additional library OpenSSL:
http://www.xstarter.com/download/openssl-0.9.7f-win32.zip

Use firewall (proxy server)
This connection mode needs if computer have not directly Internet access and connect to FTP server through firewall or proxy server.

Connect method
There are several connection modes available. Each FTP proxy server may have each own mode, it's possible to select more appropriate mode for current FTP proxy server or firewall.

Firewall host
Firewall or proxy server address in local network.

[Firewall] Port
Firewall or proxy server port.

Firewall username
Firewall or proxy server username. It can be empty if not specified at firewall or proxy server.

[Firewall] Password
Firewall or proxy server password.


FtpDelete

This Action is designed for deleting files on FTP server.

FTP Host
This is a name of the FTP server (for example, "ftp.xStarter.com").

FTP Filename
This setting defines a remote file name on the FTP server (for example, "files/log_may.log").

Username
This setting defines a login name for the user on the FTP server.

Password
This setting defines a password for the user on the FTP server.

Binary mode
Binary mode of files transfer.

SSL connection
This option allow connect to FTP server with using encrypted SSL/TLS connection. For establishing such connection you need additional library OpenSSL:
http://www.xstarter.com/download/openssl-0.9.7f-win32.zip

Use firewall (proxy server)
This connection mode needs if computer have not directly Internet access and connect to FTP server through firewall or proxy server.

Connect method
There are several connection modes available. Each FTP proxy server may have each own mode, it's possible to select more appropriate mode for current FTP proxy server or firewall.

Firewall host
Firewall or proxy server address in local network.

[Firewall] Port
Firewall or proxy server port.

Firewall username
Firewall or proxy server username. It can be empty if not specified at firewall or proxy server.

[Firewall] Password
Firewall or proxy server password.


SendICQMessage

This Action is designed for sending messages via ICQ protocol.
This Action can be used for receiving information about operations' fulfillment from a remote computer over the Internet. For example, you can receive ICQ messages on you home computer about tasks being completed on your office workstation.

Login to ICQ Information
This set of settings consists of fields for entering ICQ login parameters.

UIN
This is an ICQ address that will be used for sending messages from. It is impossible to both send and receive messages using only one ICQ address. Therefore, to use the Action for sending messages to your personal ICQ account, you would need to create a separate ICQ account. You can do so at http://lite.icq.com/register .

Password
This setting defines a password for the ICQ account.

Message To
This set of settings defines where (to which UIN) and what (Message Text) you would like to send.

UIN
Message Text


Open

This Action is designed for opening the CR-ROM drive tray. This Action can be useful for opening the tray upon pressing a special combination of keys.

Drive Letter
This is the letter assigned to the CD-ROM drive.


Close

This Action is designed for closing the CR-ROM drive tray. This Action can be useful for closing the tray upon pressing a special combination of keys.

Drive Letter
This is the letter assigned to the CD-ROM drive.


FreeMemory

This Action is designed for optimization and clearing the computer memory. This Action is especially efficient on computers under Windows 98 operating system.

Clear, Mb
This is amount of memory to be optimized / cleared.


WriteToLog

This Action is designed for writing information into a text file. If Write Date and Time before Message setting is turned on, the file can be considered as a log file for some events.

Log Filename
This is a name of the text file. If there is no such file on the hard drive, the file will be created. If the file exists, new information will be added to the end of the file.

Write Date and Time before Message
This setting tells xStarter to write current date and time in the beginning of each record.

Message
This is the text to be saved into the text file. Like all other xStarter text parameters, it can contain calls to Internal Functions, or Output Parameters of previous Actions from the current Task's list of Actions, or parameters of the Event that caused the Task's execution.

For example, it is possible to log all cases of files' modifications in a particular folder.


ReadFromLog

This Action is designed for reading information from a text file. For example, this action can be used for reading some information from text file for displaing it on the screen.

Log Filename
This is a name of the text file.

Results:
Text
This is the text to be readed from the text file.


SearchText

This Action is designed for searching information in the given text.

Search For
This setting defines the text string that is searched for.
Note: SearchText will be search text from field Search For exactly. Any parameter or internal function name entered in this field will be NOT replaced by param or function value. For example, action will search text {YEAR}{MONTH}{DAY} but not 20050726. If you need to search value, please, use action SearchParamsText .

Regular Expression
This setting states that the search will be performed with the use of regular expressions.

Return All Matches
This setting is available for regular expressions only. When turned on, the Output Parameter named "Matches" will contains all occurrences of the regular expression in the given text.

Delimiter between Matches
This setting defines a text delimiter for separating text blocks found with the use of the regular expression.

Search in Text
This is a text where the search is performed in.

Search in File
This setting turns off Search in Text option and enables searching in the given file.

Filename
This setting defines a name of the file where the search should be performed (if "Search in File" option is turned on).

Results:
Success
This parameter is set to TRUE only if "Search For" text is found.

Matches
This string contains all text blocks found with the use of the regular expression. The text blocks are separated by the text delimiter. If the text delimiter is not set, text blocks are separated by "Carriage Return" characters (ENTER).


SearchParamsText

This Action is designed for searching information in the given text.

Search For
This setting defines the text string that is searched for.
Note: Any parameter or internal function name entered in this field will be replaced by param or function value. For example, if this field have text {YEAR}{MONTH}{DAY} entered, action will search text 20050726.

Regular Expression
This setting states that the search will be performed with the use of regular expressions.

Return All Matches
This setting is available for regular expressions only. When turned on, the Output Parameter named "Matches" will contains all occurrences of the regular expression in the given text.

Delimiter between Matches
This setting defines a text delimiter for separating text blocks found with the use of the regular expression.

Search in Text
This is a text where the search is performed in.

Search in File
This setting turns off Search in Text option and enables searching in the given file.

Filename
This setting defines a name of the file where the search should be performed (if "Search in File" option is turned on).

Results:
Success
This parameter is set to TRUE only if "Search For" text is found.

Matches
This string contains all text blocks found with the use of the regular expression. The text blocks are separated by the text delimiter. If the text delimiter is not set, text blocks are separated by "Carriage Return" characters (ENTER).


CompareFiles

This Action is designed for comparing two text files.
For example, if a SQL server log file is copied to a location (different than the original one), and is later compared with the originally located log file, the difference between these files will show what changed during the time period.

If there are differences, it might be useful to copy the changed log file to yet another location and try to find out which particular error occurred. SendMail Action can be used for sending the error message to the administrator's cell phone.

Source Filename
This is a name of the original file.

Destination Filename
This is a name of the file that the original file is compared to.

Ignore Case
This setting tells xStarter to ignore case of characters in files being compared.

Ignore Blanks
This setting tells xStarter to ignore white space characters in files being compared.

Results:
SourceDiff
This is a text with changes in the source file.

DestDiff
This is a text with changes in the destination file.

LinesAdd
This is the number of newly added lines.

LinesMod
This is the number of updated lines.

LinesDel
This is the number of deleted lines.


GetTextBlockN

This Action is designed for extracting a given text block (by its number) from a text. The delimiter that separates text blocks one from another should also be set.
For example, the third text block in "World Wide Web" string with the space character as a delimiter will be "Web".

This Action can be used for searching for text blocks, related to a particular email, in Output Parameters of CheckMail Action. For example, the delimiter of CheckMail Action is set to ""|||", and there are two messages on the mail server having subjects "Hello" and "Invoice" and bodies "Hello, John, …" and "Invoice from Laboratory …". Then Output Parameters will have the following text blocks returned: MessSubjects will be "Hello|||Invoice", MessTexts will be "Hello, John, …|||Invoice from Laboratory …" and MessUidls will be "12315457792323|||457913213464".

With the use of TextLoop Statement, you can loop through subjects of emails and determine which email has to be deleted. The e-mail's ID can be extracted from MessUidls Output Parameter by GetTextBlockN Action using the number of the text block (obtained from TextLoop.LoopIndex) and the delimiter ("|||").

Specified Text
This is a text where the text block should be extracted from.

Delimiter Text
This is a delimiter that separates text blocks one from another.

Text Block Number
This is a number of the text block to be extracted from Specified Text.

Results:
TextBlock
This is the text block from Specified Text that was numbered with the given number.


WindowCommand

This Action is designed for passing commands to particular windows. The command can be, for example, minimize, maximize etc.

Window Caption
This is a caption of the window, which the command is passed to. The caption can be either entered manually or chosen from a list of currently opened windows.

Window Caption can contain wildcards, for example, "Note??d" or "*Excel*".

Don't Display Hidden Windows in the Window Caption List
This setting tells xStarter not to show hidden windows in the list of currently open windows.

Command
This field is intended for selecting a command that will be sent to the particular window.


MinimizeAllWindows

This Action is designed for minimizing all currently opened windows.


NetworkDriveConnect

Action for connecting opened network drives. It allow to open access to network computers and folders which expect username and password when ceonnecting.
After connecting via this action possible to open documents from this network resources and/or run programs.

Remote computer
Remote computer name on which shared network folders and drives are located.
For example, Server.

Remote path
Shared network drive or folder.

Username
Username for connecting to specified network resource.

Password
Password for connecting to specified network resource.

Local path
Local disk what will assigned to connecting network drive or folder. This parameter can be empty, in this case network drive will connected too, but it will not have any assigned local drive.

Reconnect after computer restart
This paramater must be selected in case of need reconnecting network drive or folder after local computer restarting.


NetworkDriveDisconnect

This action can be used for disconnecting conneced network drives and/or folders. It can be used for closing access to shared network resources (unauthorized use).

Local path
Local drive what was assigned to network resource.

Force connection, close all opened resources
This parameter must be specified for closing network resources on which are located some opened now documents or runned processes.


PlayAudio

This Action is designed for audio files play back. There are supported MP3 and WAV files in the xStarter. Only one file can be played once (and no matter in what task of xStarter).

Filename
Audio file for playing.


PlaySound

This action designed for playing of sounds for Windows system events.

Sound of program event
System event can be selected from list of elements:

Close
CriticalBatteryAlarm
DeviceConnect
DeviceDisconnect
DeviceFail
LowBatteryAlarm
MailBeep
Maximize
MenuCommand
MenuPopup
Minimize
Open
PrintComplete
RestoreDown
RestoreUp
ShowBand
SystemAsterisk
SystemExclamation
SystemExit
SystemHand
SystemNotification
SystemQuestion
SystemStart
WindowsLogoff
WindowsLogon


Statements

If and TextLoop Statements can be used in the list of Actions. The Statements are highlighted with blue ink.

The list is visualized as a tree - therefore all Actions related to an Statement are placed inside of the Statement. If an Action is not related to any Statement, the Action is placed at the top level of the tree structure.


If

This Statement allows calling Actions depending on results of comparing parameters with predefined values.

To correctly fill in the Statement, it's required to specify the parameter to be compared, the comparison operand and the value, which the parameter will be compared to.

The parameter for comparison is selected from:
q a list of Output Parameters of previous Actions in the list of the Task's Actions;
q a list of parameters of Events that caused the Task execution;
q a list of Internal Functions.

Parameters can be of different types:
q Numeric;
q String;
q Boolean;
q Date/Time.

The comparison operand can be selected depending on the parameter's type. All data types support operands = (equals) è <> (is not equal).

Different data types allow different values, which are used for comparing parameters to. The string type supports string values; numeric type requires numeric values; and Boolean needs True or False.

Actions that relate to the If Statement are executed only if comparison of the parameter to the given value was done successfully.

For example, the comparison parameter is [Ping1.Success], comparison operand is =, and comparison value is True. Then Actions related to the If Statement will be executed only if Ping1 Action was performed successfully.


TextLoop

This Statement creates a loop for Actions related to the Statement .

This Statement requires text (Specified Text), so the Actions are performed against each text block found in the Specified Text.

The text blocks are divided by a delimiter (Delimiter Text). If the delimiter is not defined, the "Carriage Return" character (ENTER) is used by default.

For example, if Specified Text is set to "World Wide Web" and the delimiter is set to " " (space character), then Actions related to the Statement will be executed 3 times for:
1. "World";
2. "Wide";
3. "Web".

It is also possible to set a loop on text blocks from a text file (External Text File).

Actions related to the TextLoop Statement can utilize the following Statement 's Output Parameters:

LoopIndex
This is an index of the current text block in Specified Text. This parameter possesses values from 1 to the number of text blocks in Specified Text;

LoopString
This is a string with the current value of the text block.